#include <bits/stdc++.h>

#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("Ofast")
#pragma GCC optimize("no-stack-protector")
#pragma GCC target("sse,sse2,sse3,ssse3,popcnt,abm,mmx,tune=native")
#pragma GCC optimize("fast-math")
#pragma GCC optimize "-O3"

using namespace std;

//#define int long long
#define all(x) begin(x),end(x)
// #define double long double
#define pb push_back

const double pi = acosl(-1);

const int MAXN = 12;
const double INF = 1e18;

double dp[1 << MAXN][MAXN];
double dists[MAXN][MAXN];

pair<double, double> rotate(double x, double y, double cs, double sn) {
  return {(x * cs - y * sn), (y * cs + x * sn)};
}

double brute_force(vector<pair<int, int>> &pts, double ang) {
  double cs = cosl(ang);
  double sn = sinl(ang);
  int n = pts.size();
  for (int i = 0; i < n; ++i) {
    for (int j = i + 1; j < n; ++j) {
      auto pt1 = rotate(pts[i].first, pts[i].second, cs, sn);
      auto pt2 = rotate(pts[j].first, pts[j].second, cs, sn);
      double dist = abs(pt1.first - pt2.first) + abs(pt1.second - pt2.second);
      dists[i][j] = dist;
      dists[j][i] = dist;
    }
  }
  
  vector<int> p(pts.size());
  iota(p.begin(), p.end(), 0);
  
  double ans = INF;
  do{
    double tmp = 0;
    for(int i = 1; i < pts.size(); ++i){
      tmp += dists[p[i - 1]][p[i]];
    }
    ans = min(ans, tmp);
  }while(next_permutation(p.begin(), p.end()));
  return ans;
}


signed main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  int n;
  cin >> n;
  vector<pair<int, int>> pts(n);
  for (auto &el : pts) {
    cin >> el.first >> el.second;
  }
  vector<double> angs;
  for (int i = 0; i < n; ++i) {
    for (int j = i + 1; j < n; ++j) {
      double ang = atan2l(pts[i].second - pts[j].second, pts[i].first - pts[j].first);
      angs.push_back(-ang);
      angs.push_back(-ang + pi / 2);
    }
  }

  double ans = INF;
  for (auto ang : angs) {
    ans = min(ans, brute_force(pts, ang));
  }
  cout << fixed << setprecision(20) << ans << '\n';
}