#include <bits/stdc++.h>

using namespace std;

//#define int long long
#define all(x) begin(x),end(x)
#define double long double
#define pb push_back

const double pi = acosl(-1);

const int MAXN = 12;
const double INF = 1e18;

double dp[1 << MAXN][MAXN];
double dists[MAXN][MAXN];

pair<double, double> rotate(double x, double y, double cs, double sn) {
  return {(x * cs - y * sn), (y * cs + x * sn)};
}

double cumivoyazhor(vector<pair<int, int>> &pts, double ang) {
  double cs = cosl(ang);
  double sn = sinl(ang);
  int n = pts.size();
  for (int i = 0; i < n; ++i) {
    for (int j = i + 1; j < n; ++j) {
      auto pt1 = rotate(pts[i].first, pts[i].second, cs, sn);
      auto pt2 = rotate(pts[j].first, pts[j].second, cs, sn);
      double dist = abs(pt1.first - pt2.first) + abs(pt1.second - pt2.second);
      dists[i][j] = dist;
      dists[j][i] = dist;
    }
  }
  for (int i = 0; i < n; ++i) {
    dp[1 << i][i] = 0;
  }
  for (int mask = 1; mask < (1 << n); ++mask) {
    vector<int> now;
    for (int b = 0; b < n; ++b) {
      if (mask & (1 << b)) {
        now.push_back(b);
      }
    }
    if (now.size() == 1) {
      continue;
    }
    for (int last : now) {
      dp[mask][last] = INF;
      for (int prev_last : now) {
        if (last == prev_last) {
          continue;
        }
        dp[mask][last] = min(dp[mask][last], dp[mask ^ (1 << last)][prev_last] + dists[last][prev_last]);
      }
    }
  }
  double ans = INF;
  int full_mask = (1 << n) - 1;
  for (int i = 0; i < n; ++i) {
    ans = min(ans, dp[full_mask][i]);
  }
  return ans;
}


signed main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  int n;
  cin >> n;
  vector<pair<int, int>> pts(n);
  for (auto &el : pts) {
    cin >> el.first >> el.second;
  }
  vector<double> angs;
  for (int i = 0; i < n; ++i) {
    for (int j = i + 1; j < n; ++j) {
      double ang = atan2l(pts[i].second - pts[j].second, pts[i].first - pts[j].first);
      angs.push_back(-ang);
      angs.push_back(-ang + pi / 2);
    }
  }
//  for (int i = 0; i < 10000; ++i) {
//    angs.push_back(pi / 10000 * i);
//  }
  double ans = INF;
  for (auto ang : angs) {
    ans = min(ans, cumivoyazhor(pts, ang));
  }
  cout << fixed << setprecision(20) << ans << '\n';
}